'SuperXLe Basic English
'2018/7/11
'WEB https://superxle-english.amebaownd.com/
'-------------------------------------------------------------------------------------------
Const FOLDER_NAME = "SuperXLe_Basic_English"
Const FOLDER_NAME2 = "SuperXLe_Usage_Record"
Const FOLDER_NAME3 = "SuperXLe_Option"
Const FILLE_NAME = "SuperXLe_Basic_English.xlam"

Const TABLE_NAME = "SuperXLe_Table_InTouch_English.xls"
Const TABLE_NAME2 = "SuperXLe_Table3_English.xlsm"

Const addInName = "SuperXLe Basic English"

Dim ExcelVersion
Dim officeVer

ExcelVersion = GetOfficeVer("Excel")

Select Case ExcelVersion
    Case "Excel2010"
       MsgBox "Your Excel version is " & ExcelVersion & "." & vbCrLf _
          & addInName & " can be installed.", vbOKOnly + vbInformation, addInName
       Call Install
    Case "Excel2013"
       MsgBox "Your Excel version is " & ExcelVersion & "." & vbCrLf _
          & addInName & " can be installed.", vbOKOnly + vbInformation, addInName
       Call Install
    Case "Excel2016"
       MsgBox "Your Excel version is " & ExcelVersion & "." & vbCrLf _
          & addInName & " can be installed.", vbOKOnly + vbInformation, addInName
       Call Install
    Case "not_installed"
       MsgBox "Excel is not installed on your PC." _
          , vbOKOnly + vbExclamation, addInName
    Case Else
       MsgBox "Your Excel version is " & ExcelVersion & "." & vbCrLf _
          & addInName & " is not supported." _
          , vbOKOnly + vbExclamation, addInName
End Select
'-------------------------------------------------------------------------------------------
Sub Regedit()   'Register "trusted folder" registered

    Dim objShell, i, iWordWrap
    Dim HKEY_Path
    
    Set objExcel = CreateObject("Excel.Application")
    strAdPath = objExcel.Application.UserLibraryPath & "SuperXLe_Basic_English"
    
    Set objShell = Wscript.CreateObject("WScript.Shell")
    
    On Error Resume Next
    
    Err.Number = 0
    i = -1
    Do Until Err.Number <> 0
        i = i + 1
        HKEY_Path = "HKEY_CURRENT_USER\Software\Microsoft\Office\" & officeVer & "\Excel\Security\Trusted Locations\Location" & i & "\Path"
        iWordWrap = objShell.RegRead(HKEY_Path)
        If iWordWrap = strAdPath Then Err.Number = 100
    Loop
    
    If Err.Number = 100 Then
    Else
        objShell.RegWrite HKEY_Path, strAdPath, "REG_SZ"
	objShell.RegWrite Replace(HKEY_Path, "Path", "AllowSubFolders"), 1, "REG_DWORD"
	objShell.RegWrite Replace(HKEY_Path, "Path", "Description"), "for SuperXLe_Basic_English", "REG_SZ"
    End If
    Err.Clear

End Sub
'-------------------------------------------------------------------------------------------
Sub Install()

    On Error Resume Next

    Dim objExcel
    Dim strAdPath
    Dim strMyPath
    Dim strAdCp, strAdCp2, strAdCp3, strAdCp4, strAdCp5, strAdCp6
    Dim strMyCp, strMyCp2, strMyCp3, strMyCp4, strMyCp5, strMyCp6
    Dim objFileSys, objShell
    Dim oAdd
    Dim objFolder, objFile, excel0

    Set excel0 = GetObject(, "Excel.Application")
    Set excel0 = nothing
    If Err.Number = 0 Then
      MsgBox "Excel is running !" & vbCrLf & "Please temporarily close it and run this VBS again.", _
      vbExclamation, addInName
      Wscript.Quit
    End If
    Err.Clear

    'Installation confirmation window
    If MsgBox("Do you want to run as a user with administrator authority?" & vbCrLf & addInName & " Install?", _
    vbYesNo + vbQuestion, addInName) = vbNo Then
        Wscript.Quit
    End If

    MsgBox "Installation will start." & vbCrLf & "Please wait for 5 to 60 seconds " & vbCrLf & "as it is until the end popup is displayed.", _
    vbOKOnly + vbInformation, addInName

    'Excel instantiation
    Set objExcel = CreateObject("Excel.Application")
    Set objFileSys = CreateObject("Scripting.FileSystemObject")

    'Path setting
    strAdPath = objExcel.Application.UserLibraryPath & FOLDER_NAME  'SuperXLe_Basic_English
    strAdPath2 = strAdPath & "\" & FOLDER_NAME2             'SuperXLe add-in usage track record
    strAdPath3 = strAdPath & "\" & FOLDER_NAME3             'SuperXLe option
    strMyPath = Replace(Wscript.ScriptFullName, Wscript.ScriptName, "")

    strAdCp = objFileSys.BuildPath(strAdPath, FILLE_NAME)   'SuperXLe_Basic_English.xlam
    strMyCp = objFileSys.BuildPath(strMyPath, FILLE_NAME)
    strAdCp2 = objFileSys.BuildPath(strAdPath3, TABLE_NAME)     'SuperXLe_Table_InTouch_English.xls
    strMyCp2 = objFileSys.BuildPath(strMyPath, TABLE_NAME)
    strAdCp3 = strAdPath & "\FCChecker.1.2.0"
    strMyCp3 = strMyPath & "\FCChecker.1.2.0"
    strAdCp4 = objFileSys.BuildPath(strAdPath3, TABLE_NAME2)    'SuperXLe_Table3_English.xlsm
    strMyCp4 = objFileSys.BuildPath(strMyPath, TABLE_NAME2)
    strAdCp5 = strAdPath & "\Logo"
    strMyCp5 = strMyPath & "\Logo"
    strAdCp6 = strAdPath & "\GetString"
    strMyCp6 = strMyPath & "\GetString"

    'Create folder
    If objFileSys.FolderExists(strAdPath) = False Then  'SuperXLe_Basic
        objFileSys.CreateFolder (strAdPath)
    End If
    If objFileSys.FolderExists(strAdPath2) = False Then 'SuperXLe add-in usage track record
        objFileSys.CreateFolder (strAdPath2)
    End If
    If objFileSys.FolderExists(strAdPath3) = False Then 'SuperXLe option
        objFileSys.CreateFolder (strAdPath3)
    End If

    'Folder/file copy
    objFileSys.CopyFile strMyCp, strAdCp    'SuperXLe_Basic.xlam
    objFileSys.CopyFile strMyCp2, strAdCp2  'SuperXLe_Table_InTouch.xls
    objFileSys.CopyFolder strMyCp3, strAdCp3    'FCChecker
    objFileSys.CopyFolder strMyCp5, strAdCp5    'logo mark
    objFileSys.CopyFolder strMyCp6, strAdCp6    'Get character at point position

    'SuperXLe_Table3.xlsm overwrite confirmation
    If objFileSys.FileExists(strAdCp4) = True Then
        If MsgBox("Personal table exists." & vbCrLf & "Do you want to reset the contents?", _
       vbYesNo + vbQuestion, addInName) = vbYes Then
            objFileSys.CopyFile strMyCp4, strAdCp4  'SuperXLe_Table3.xlsm
        End If
    Else
        objFileSys.CopyFile strMyCp4, strAdCp4  'SuperXLe_Table3.xlsm
    End If

    Set Excel = objExcel.Workbooks.Open(strAdCp4)
    Set Sheet = Excel.Worksheets("Menu_System")
    Sheet.Cells(Sheet.Cells(2, 12), 6) = strAdCp5   'logo mark folder
    Sheet.Cells(2, 13) = 1              'Installation (0: Installed, 1: Installing)
    Excel.Save
    Set Excel = Nothing
    Set Sheet = Nothing

    'Addin Registration
    objExcel.Workbooks.Add
    Set oAdd = objExcel.AddIns.Add(strAdCp, True)

    'Addin enable
    ''An error occurred, an object is required' message may be displayed
    oAdd.Installed = True
    objExcel.Quit

    Set objExcel = Nothing
    Set objFileSys = Nothing

    If Err.Number = 0 Then
       MsgBox "Thank you for install " & addInName & "." & vbCrLf & vbCrLf _
    & "Continue to check the properties of the add-in file." & vbCrLf _
        & "Please wait for a while now.", _
    vbOKOnly + vbInformation, addInName

       Set objShell = CreateObject("Shell.Application")
       Set objFolder = objShell.Namespace(strAdPath)
       Set objFile = objFolder.ParseName(FILLE_NAME)
       objFile.InvokeVerb ("properties")

       MsgBox "Files acquired from outside may be blocked by Excel." & vbCrLf & _
        "Open the properties of the add - in file, please unblock." & vbCrLf & vbCrLf & _
        "If there is no indication of Release of block relation in the last of the General tab, it is already released." & vbCrLf & _
        "In this case please Cancel as it is.", vbOKOnly + vbInformation, addInName
        
        Call Regedit    'Register "trusted folder" in registry
    Else
       MsgBox "Error occurred." & vbCrLf & "Please close it if Excel is running.", vbOKOnly + vbExclamation, addInName
    End If

    Set objShell = Nothing
    Set objFolder = Nothing
    Set objFile = Nothing

End Sub

'-----------------------------------------------------------------------------
'Processing content: Obtain version of Office product
'Argument: Application name (Excel Word Powerpoint Access)
'Returns: Office product version
'-----------------------------------------------------------------------------
Function GetOfficeVer(appName)

'http://support.microsoft.com/kb/240794/ja
  On Error Resume Next
  Err.Clear
  Dim strRet
  strRet = ""
  officeVer = ""
  Dim Obj

  Dim Shell
  Dim RegKey
  Set Shell = CreateObject("WScript.Shell")
  Dim KeyG
  KeyG = appName & ".Application"
  RegKey = "HKLM\SOFTWARE\Classes\" & KeyG & "\CurVer\"
  officeVer = UCase(Shell.RegRead(RegKey))
  KeyG = UCase(KeyG)
  officeVer = Replace(officeVer, KeyG, "", 1, -1, 1)

  Set Shell = Nothing
  If Err.Number = 0 Then
    Select Case officeVer
      Case ".8"
        strRet = appName & "97"
      Case ".9"
        strRet = appName & "2000"
      Case ".10"
        strRet = appName & "XP"
      Case ".11"
        strRet = appName & "2003"
      Case ".12"
        strRet = appName & "2007"
      Case ".14"
        strRet = appName & "2010"
        officeVer = "14.0"
      Case ".15"
        strRet = appName & "2013"
        officeVer = "15.0"
      Case ".16"
        strRet = appName & "2016"
        officeVer = "16.0"
      Case Else
        strRet = appName & "(" & officeVer & ")"
    End Select
  Else
    strRet = "not_installed"
  End If

'strRet = "not installed"
'strRet = appName & "2018"

  GetOfficeVer = strRet
  Err.Clear
  
End Function

